﻿function make_multiple_to(number_p,divider_p){
	if(number_p%1!=0 && number_p%divider_p!=0) number_p = Math.ceil(number_p/divider_p)*divider_p;
	return number_p;
}

function get_original_device_index(global_idx_p){
	var ts = global_idx_p;
	if(ts<devices.length) return ts;
	ts -= devices.length;
	if(ts<engines.length) return ts;
	ts -= engines.length;
	if(ts<batteries.length) return ts;
	ts -= batteries.length;
	if(ts<weapons.length) return ts;
	ts -= weapons.length;
	if(ts<armor_plates_1.length) return ts;
	ts -= armor_plates_1.length;
	if(ts<armor_shields.length) return ts;
	ts -= armor_shields.length;
	if(ts<armor_plates_2.length) return ts;
	ts -= armor_plates_2.length;
	if(ts<armor_plates_3.length) return ts;
	//ts -= armor_plates_3.length;
	return null;
}
//элементы для клонирования
var remove_button_template = $("<div>x</div>").addClass("remove_button");
var mod_toggle_button_template = $("<span>вкл./выкл.</span>").addClass("mod_toggle_button");
var user_input_template = $("<input></input>").attr("maxLength",2).attr("type","text");

var min_rk=3, max_rk=8;

//скорости по рк
var basic_speed = [4,3,3,2,2,2];
//базовая надбавка к скорости при беге
var basic_speed_boost = 2;
//константы для расчета хитов в сегментах
var rk_consts = [1500,2200,3100,4200,5500,7000];
//вместимости по рк
var capacities = [15,25,38,53,70,90];
var lower_capacity_limit = [12,19,30,44,60,78];
//цены ТА по рк [min, max]
var nominal_prices = [[35000,40000],[55000,55000],[84000,84000],[116000,116000],[154000,154000],[198000,198000]];
//допустимая отклонение в цене
var price_deviation = 100;

//утончение / уплотнение брони
var shield_size = [
	new ImplementationOption("малый"),
	new ImplementationOption("средн.",
		function(device_param){
			var tp = device_param.attr[_price].value;
			var tw = device_param.attr[_weight].value;
			var th = device_param.aditional_param;
			device_param.attr[_price].value = Math.ceil(tp*2);
			device_param.attr[_weight].value = Math.ceil(tw*2);
			device_param.aditional_param = Math.ceil(th*2);
		}),
	new ImplementationOption("больш.", 
		function(device_param){
			var tp = device_param.attr[_price].value;
			var tw = device_param.attr[_weight].value;
			var th = device_param.aditional_param;
			device_param.attr[_price].value = Math.ceil(tp*3);
			device_param.attr[_weight].value = Math.ceil(tw*3);
			device_param.aditional_param = Math.ceil(th*3);
		})
];
var armor_hardering = [
	new ImplementationOption("100%"),
	new ImplementationOption(" 90%", 
		function(device_param){
			var tp = device_param.attr[_price].value;
			var tw = device_param.attr[_weight].value;
			var th = device_param.aditional_param;
			device_param.attr[_price].value = Math.ceil(tp*0.9);
			device_param.attr[_weight].value = Math.ceil(tw*0.9);
			device_param.aditional_param = Math.ceil(th*0.9);
		}),
	new ImplementationOption(" 80%", 
		function(device_param){
			var tp = device_param.attr[_price].value;
			var tw = device_param.attr[_weight].value;
			var th = device_param.aditional_param;
			device_param.attr[_price].value = Math.ceil(tp*0.8);
			device_param.attr[_weight].value = Math.ceil(tw*0.8);
			device_param.aditional_param = Math.ceil(th*0.8);
		}),
	new ImplementationOption(" 70%", 
		function(device_param){
			var tp = device_param.attr[_price].value;
			var tw = device_param.attr[_weight].value;
			var th = device_param.aditional_param;
			device_param.attr[_price].value = Math.ceil(tp*0.7);
			device_param.attr[_weight].value = Math.ceil(tw*0.7);
			device_param.aditional_param = Math.ceil(th*0.7);
		}),
	new ImplementationOption(" 60%", 
		function(device_param){
			var tp = device_param.attr[_price].value;
			var tw = device_param.attr[_weight].value;
			var th = device_param.aditional_param;
			device_param.attr[_price].value = Math.ceil(tp*0.6);
			device_param.attr[_weight].value = Math.ceil(tw*0.6);
			device_param.aditional_param = Math.ceil(th*0.6);
		}),
	new ImplementationOption(" 50%", 
		function(device_param){
			var tp = device_param.attr[_price].value;
			var tw = device_param.attr[_weight].value;
			var th = device_param.aditional_param;
			device_param.attr[_price].value = Math.ceil(tp*0.5);
			device_param.attr[_weight].value = Math.ceil(tw*0.5);
			device_param.aditional_param = Math.ceil(th*0.5);
		}),
	new ImplementationOption(" 40%", 
		function(device_param){
			var tp = device_param.attr[_price].value;
			var tw = device_param.attr[_weight].value;
			var th = device_param.aditional_param;
			device_param.attr[_price].value = Math.ceil(tp*0.4);
			device_param.attr[_weight].value = Math.ceil(tw*0.4);
			device_param.aditional_param = Math.ceil(th*0.4);
		}),
	new ImplementationOption(" 30%", 
		function(device_param){
			var tp = device_param.attr[_price].value;
			var tw = device_param.attr[_weight].value;
			var th = device_param.aditional_param;
			device_param.attr[_price].value = Math.ceil(tp*0.3);
			device_param.attr[_weight].value = Math.ceil(tw*0.3);
			device_param.aditional_param = Math.ceil(th*0.3);
		}),
	new ImplementationOption(" 20%", 
		function(device_param){
			var tp = device_param.attr[_price].value;
			var tw = device_param.attr[_weight].value;
			var th = device_param.aditional_param;
			device_param.attr[_price].value = Math.ceil(tp*0.2);
			device_param.attr[_weight].value = Math.ceil(tw*0.2);
			device_param.aditional_param = Math.ceil(th*0.2);
		}),
	new ImplementationOption(" 10%", 
		function(device_param){
			var tp = device_param.attr[_price].value;
			var tw = device_param.attr[_weight].value;
			var th = device_param.aditional_param;
			device_param.attr[_price].value = Math.ceil(tp*0.1);
			device_param.attr[_weight].value = Math.ceil(tw*0.1);
			device_param.aditional_param = Math.ceil(th*0.1);
		}),
	new ImplementationOption("110%", 
		function(device_param){
			var tp = device_param.attr[_price].value;
			var tw = device_param.attr[_weight].value;
			var th = device_param.aditional_param;
			device_param.attr[_price].value = Math.ceil(tp*1.1);
			device_param.attr[_weight].value = Math.ceil(tw*1.1);
			device_param.aditional_param = Math.ceil(th*1.1);
		}),
	new ImplementationOption("120%", 
		function(device_param){
			var tp = device_param.attr[_price].value;
			var tw = device_param.attr[_weight].value;
			var th = device_param.aditional_param;
			device_param.attr[_price].value = Math.ceil(tp*1.2);
			device_param.attr[_weight].value = Math.ceil(tw*1.2);
			device_param.aditional_param = Math.ceil(th*1.2);
		}),
	new ImplementationOption("130%", 
		function(device_param){
			var tp = device_param.attr[_price].value;
			var tw = device_param.attr[_weight].value;
			var th = device_param.aditional_param;
			device_param.attr[_price].value = Math.ceil(tp*1.3);
			device_param.attr[_weight].value = Math.ceil(tw*1.3);
			device_param.aditional_param = Math.ceil(th*1.3);
		}),
	new ImplementationOption("140%", 
		function(device_param){
			var tp = device_param.attr[_price].value;
			var tw = device_param.attr[_weight].value;
			var th = device_param.aditional_param;
			device_param.attr[_price].value = Math.ceil(tp*1.4);
			device_param.attr[_weight].value = Math.ceil(tw*1.4);
			device_param.aditional_param = Math.ceil(th*1.4);
		}),
	new ImplementationOption("150%", 
		function(device_param){
			var tp = device_param.attr[_price].value;
			var tw = device_param.attr[_weight].value;
			var th = device_param.aditional_param;
			device_param.attr[_price].value = Math.ceil(tp*1.5);
			device_param.attr[_weight].value = Math.ceil(tw*1.5);
			device_param.aditional_param = Math.ceil(th*1.5);
		}),
	new ImplementationOption("160%", 
		function(device_param){
			var tp = device_param.attr[_price].value;
			var tw = device_param.attr[_weight].value;
			var th = device_param.aditional_param;
			device_param.attr[_price].value = Math.ceil(tp*1.6);
			device_param.attr[_weight].value = Math.ceil(tw*1.6);
			device_param.aditional_param = Math.ceil(th*1.6);
		}),
	new ImplementationOption("170%", 
		function(device_param){
			var tp = device_param.attr[_price].value;
			var tw = device_param.attr[_weight].value;
			var th = device_param.aditional_param;
			device_param.attr[_price].value = Math.ceil(tp*1.7);
			device_param.attr[_weight].value = Math.ceil(tw*1.7);
			device_param.aditional_param = Math.ceil(th*1.7);
		}),
	new ImplementationOption("180%", 
		function(device_param){
			var tp = device_param.attr[_price].value;
			var tw = device_param.attr[_weight].value;
			var th = device_param.aditional_param;
			device_param.attr[_price].value = Math.ceil(tp*1.8);
			device_param.attr[_weight].value = Math.ceil(tw*1.8);
			device_param.aditional_param = Math.ceil(th*1.8);
		}),
	new ImplementationOption("190%", 
		function(device_param){
			var tp = device_param.attr[_price].value;
			var tw = device_param.attr[_weight].value;
			var th = device_param.aditional_param;
			device_param.attr[_price].value = Math.ceil(tp*1.9);
			device_param.attr[_weight].value = Math.ceil(tw*1.9);
			device_param.aditional_param = Math.ceil(th*1.9);
		}),
	new ImplementationOption("200%", 
		function(device_param){
			var tp = device_param.attr[_price].value;
			var tw = device_param.attr[_weight].value;
			var th = device_param.aditional_param;
			device_param.attr[_price].value = Math.ceil(tp*2);
			device_param.attr[_weight].value = Math.ceil(tw*2);
			device_param.aditional_param = Math.ceil(th*2);
		})
];
//типы размещения и тюнинга оружия
var double_ammo = [
	new ImplementationOption("стд.магаз."),
	new ImplementationOption(" + РМ ", 
		function(device_param){
			var tp = device_param.attr[_price].value;
			var tw = device_param.attr[_weight].value;
			device_param.attr[_price].value = tp*1.25;
			device_param.attr[_weight].value = tw*1.5;
		})
];
var accuracy_improove = [
	new ImplementationOption("обыч.точн."),
	new ImplementationOption(" + T ", //РУ
		function(device_param, def_dev_p){
			var tp = device_param.attr[_price].value;
			var tc = def_dev_p.attr[_size].value;
			device_param.attr[_price].value = tp + 500*(10 + 2*tc);
		})
]
var damage_boost = [
	new ImplementationOption("обыч.урон"),
	new ImplementationOption(" + У1 ", //АП, ПУ, АО
		function(device_param){
			var tp = device_param.attr[_price].value;
			device_param.attr[_price].value = tp + 1000;
		}),
	new ImplementationOption(" + У2 ", //АП, ПУ, АО
		function(device_param){
			var tp = device_param.attr[_price].value;
			device_param.attr[_price].value = tp + 2000;
		}),
	new ImplementationOption(" + У3 ", //АП, ПУ, АО
		function(device_param){
			var tp = device_param.attr[_price].value;
			device_param.attr[_price].value = tp + 3000;
		}),
	new ImplementationOption(" + У4 ", //АП, ПУ, АО
		function(device_param){
			var tp = device_param.attr[_price].value;
			device_param.attr[_price].value = tp + 4000;
		}),
	new ImplementationOption(" + У5 ", //АП, ПУ, АО
		function(device_param){
			var tp = device_param.attr[_price].value;
			device_param.attr[_price].value = tp + 5000;
		}),
	new ImplementationOption(" + У ", //ЛП
		function(device_param, def_dev_p){
			var tc = def_dev_p.attr[_size].value;
			var tp = device_param.attr[_price].value;
			device_param.attr[_price].value = tp + tc*1000;
		}),
];
var heat_reduce = [
	new ImplementationOption("обыч.нагрев"),
	new ImplementationOption(" + O1 ",
		function(device_param, def_dev_p){
			var tc = def_dev_p.attr[_size].value;
			var tr = def_dev_p.attr[_warming].value;
			var tp = device_param.attr[_price].value;
			device_param.attr[_price].value = tp + 30*(10-tr+tc);
			device_param.attr[_size].value += 1;
		}),
	new ImplementationOption(" + O2 ",
		function(device_param, def_dev_p){
			var tc = def_dev_p.attr[_size].value;
			var tr = def_dev_p.attr[_warming].value;
			var tp = device_param.attr[_price].value;
			device_param.attr[_price].value = tp + 30*(2*(10-tr+tc)+1);
			device_param.attr[_size].value += 1;
		}),
	new ImplementationOption(" + O3 ",
		function(device_param, def_dev_p){
			var tc = def_dev_p.attr[_size].value;
			var tr = def_dev_p.attr[_warming].value;
			var tp = device_param.attr[_price].value;
			device_param.attr[_price].value = tp + 30*(3*(10-tr+tc)+2);
			device_param.attr[_size].value += 1;
		}),
	new ImplementationOption(" + O4 ",
		function(device_param, def_dev_p){
			var tc = def_dev_p.attr[_size].value;
			var tr = def_dev_p.attr[_warming].value;
			var tp = device_param.attr[_price].value;
			device_param.attr[_price].value = tp + 30*(4*(10-tr+tc)+3);
			device_param.attr[_size].value += 1;
		}),
	new ImplementationOption(" + O5 ",
		function(device_param, def_dev_p){
			var tc = def_dev_p.attr[_size].value;
			var tr = def_dev_p.attr[_warming].value;
			var tp = device_param.attr[_price].value;
			device_param.attr[_price].value = tp + 30*(5*(10-tr+tc)+4);
			device_param.attr[_size].value += 1;
		}),
];
var range_increase = [
	new ImplementationOption(" + Д ",//для АП, ПУ, АО
		function(device_param, def_dev_p){
			var tc = def_dev_p.attr[_size].value;
			var tr = def_dev_p.aditional_param;
			var tp = device_param.attr[_price].value;
			device_param.attr[_price].value = tp + 300*(10-tr+tc);
			var tw = def_dev_p.attr[_weight].value;
			device_param.attr[_weight].value = tw*1.5;
		}),
	new ImplementationOption(" + Д ",//для огнемета, ЛП
		function(device_param, def_dev_p){
			var tc = def_dev_p.attr[_size].value;
			var tr = def_dev_p.aditional_param;
			var tp = device_param.attr[_price].value;
			device_param.attr[_price].value = tp + 300*(10-tr+tc);
		}),
	new ImplementationOption(" + Д ",//для ПП
		function(device_param, def_dev_p){
			var tc = def_dev_p.attr[_size].value;
			var tr = def_dev_p.aditional_param;
			var tp = device_param.attr[_price].value;
			device_param.attr[_price].value = tp + 300*(10-tr+tc);
			device_param.attr[_size].value += 1;
		}),
	new ImplementationOption(" + ДД ",//для ПП
		function(device_param, def_dev_p){
			var tc = def_dev_p.attr[_size].value;
			var tr = def_dev_p.aditional_param;
			var tp = device_param.attr[_price].value;
			device_param.attr[_price].value = tp + 600*(10-tr+tc)+300;
			device_param.attr[_size].value += 1;
		}),
	new ImplementationOption("станд.дальн.")
];
var waxwork = [
	new ImplementationOption("ориг."),
	new ImplementationOption("муляж",
		function(device_param){
			var tp = device_param.attr[_price].value;
			device_param.attr[_price].value = Math.ceil(tp/5)+500;
			var tw = device_param.attr[_weight].value;
			device_param.attr[_weight].value = Math.ceil(tw/4);
			var tc = device_param.attr[_size].value;
			device_param.attr[_size].value = Math.ceil(tc/2);
		})
];
var weapon_allocation_types = [
	new ImplementationOption("фронт"),
	new ImplementationOption("бок"),
	new ImplementationOption("тыл")
];
var weapon_angle = [
	new ImplementationOption("м.у.п."),
	new ImplementationOption("б.у.п.")
];
//типы размещения всех девайсов
var device_allocation_types = [
	new ImplementationOption("внутр."),
	new ImplementationOption("наружн.",
		function(device_param){
			var tc = device_param.attr[_size].value;
			device_param.attr[_size].value = make_multiple_to(tc/2,0.5);
		})
];
var device_implementation_types = [
	new ImplementationOption("SS"),
	new ImplementationOption("DS",
		function(device_param){
			var tc = device_param.attr[_size].value;
			var tw = device_param.attr[_weight].value;
			var tp = device_param.attr[_price].value;
			device_param.attr[_size].value = make_multiple_to(tc*1.5,0.5);
			device_param.attr[_weight].value = make_multiple_to(tw*1.25,0.5);
			device_param.attr[_price].value = make_multiple_to(tp*1.25,0.5);
		})
];
//типы ТШ
var torso_degree = [
	new ImplementationOption("60"),
	new ImplementationOption("120",
		function(device_param){
			device_param.attr[_weight].value *= 2;
			device_param.attr[_price].value *= 2;
		}),
	new ImplementationOption("180",
		function(device_param){
			device_param.attr[_weight].value *= 3;
			device_param.attr[_price].value *= 3;
		})
];
//ЕМ динамики
var em = [
	new ImplementationOption("EM1"),
	new ImplementationOption("EM2",function(device_param){device_param.attr[_weight].value*=2;device_param.attr[_price].value*=2;}),
	new ImplementationOption("EM3",function(device_param){device_param.attr[_weight].value*=3;device_param.attr[_price].value*=3;}),
	new ImplementationOption("EM4",function(device_param){device_param.attr[_weight].value*=4;device_param.attr[_price].value*=4;}),
	new ImplementationOption("EM5",function(device_param){device_param.attr[_weight].value*=5;device_param.attr[_price].value*=5;}),
	new ImplementationOption("EM6",function(device_param){device_param.attr[_weight].value*=6;device_param.attr[_price].value*=6;}),
	new ImplementationOption("EM7",function(device_param){device_param.attr[_weight].value*=7;device_param.attr[_price].value*=7;}),
	new ImplementationOption("EM8",function(device_param){device_param.attr[_weight].value*=8;device_param.attr[_price].value*=8;}),
	new ImplementationOption("EM9",function(device_param){device_param.attr[_weight].value*=9;device_param.attr[_price].value*=9;}),
	new ImplementationOption("EM10",function(device_param){device_param.attr[_weight].value*=10;device_param.attr[_price].value*=10;}),
	new ImplementationOption("EM12",function(device_param){device_param.attr[_weight].value*=12;device_param.attr[_price].value*=12;}),
	new ImplementationOption("EM14",function(device_param){device_param.attr[_weight].value*=14;device_param.attr[_price].value*=14;}),
	new ImplementationOption("EM16",function(device_param){device_param.attr[_weight].value*=16;device_param.attr[_price].value*=16;}),
	new ImplementationOption("EM18",function(device_param){device_param.attr[_weight].value*=18;device_param.attr[_price].value*=18;}),
	new ImplementationOption("EM20",function(device_param){device_param.attr[_weight].value*=20;device_param.attr[_price].value*=20;}),
	new ImplementationOption("EM25",function(device_param){device_param.attr[_weight].value*=25;device_param.attr[_price].value*=25;}),
	new ImplementationOption("EM30",function(device_param){device_param.attr[_weight].value*=30;device_param.attr[_price].value*=30;})
];
//типы техники
var tech_types = [
	new Tech_Type("шагающие машины",1),
	new Tech_Type("авиатехника",2)
];

//девайсы- name, price, size, warming, installed, controlled_by, description, 
//controlls_area, weight, allowed_segments, max_count, options, composite_name
var devices = [
	new MDevice("станд. кабина",0,0,0,[_sg_cockpit],null,"место пилота",_this_segment,0,null,1),
	new MDevice("станд. оруж. порт",0,0,0,[_sg_nose,_sg_cockpit,_sg_torso,_sg_tail,_sg_wings,_sg_legs,_sg_hands],null,"необходим для установки оружия",_this_segment,0,null,1),
	new MDevice("блокиратор управления",0,0,0,[_sg_cockpit],[[_standard_cab],[_extra_cab]],"выключает машину при перегреве",_all_segments,0,null,1),
	new MDevice("реактор R1",2500,0.5,0.5,null,null,"генератор энергии",null,500,[_sg_nose,_sg_cockpit,_sg_torso,_sg_tail]),
	new MDevice("реактор R2",5000,1,1,null,null,"генератор энергии",null,1000,[_sg_nose,_sg_cockpit,_sg_torso,_sg_tail]),
	new MDevice("реактор R3",10000,2,1.5,null,null,"генератор энергии",null,2000,[_sg_nose,_sg_cockpit,_sg_torso,_sg_tail]),
	new MDevice("генератор G1",
		function(){return this.attr[_bmd].value*800;},
		function(){return this.attr[_bmd].value/4;},
		0,null,null,"генератор энергии",null,
		function(){return this.attr[_bmd].value*100;},
		[_sg_nose,_sg_cockpit,_sg_torso,_sg_tail]),
	new MDevice("генератор G2",
		function(){return this.attr[_bmd].value*1200;},
		function(){return this.attr[_bmd].value/3;},
		0,null,null,"генератор энергии",null,
		function(){return this.attr[_bmd].value*150;},
		[_sg_nose,_sg_cockpit,_sg_torso,_sg_tail]),
	new MDevice("дополн. кабина",1000,1,0,null,null,"место пилота",_this_segment,100,[_sg_cockpit,_sg_torso]),
	new MDevice("амортиз. кресла",500,0,0,null,[[_standard_cab],[_extra_cab]],"амортизация кресла",null,50,[_sg_cockpit,_sg_torso]),
	new MDevice("ГЩ",2000,1,0.2,null,null,"генератор щита",null,700,[_sg_nose,_sg_cockpit,_sg_torso,_sg_hands,_sg_legs,_sg_tail],1),
	new MDevice("ГЩВМ",4900,3,0.4,null,null,"генератор щита высокой мощности",null,1500,[_sg_nose,_sg_cockpit,_sg_torso,_sg_hands,_sg_legs,_sg_tail],1),
	new MDevice("датчик нагрева",500,0,0,null,[[_standard_cab],[_extra_cab]],"дистанционное определение нагрева цели",null,50,[_sg_cockpit,_sg_torso]),
	new MDevice("дополн. оруж. порт",1000,0,0,null,null,"необходим для установки оружия",_this_segment,0,[_sg_nose,_sg_cockpit,_sg_torso,_sg_tail,_sg_wings,_sg_legs,_sg_hands]),
	new MDevice("ECM",4500,1,0,null,null,"создает противоракетные помехи вокруг меха",null,300,[_sg_cockpit,_sg_torso]),
	new MDevice("катапульта",250,0,0,null,[[_standard_cab],[_extra_cab]],"катапульта",null,50,[_sg_cockpit,_sg_torso]),
	new MDevice("нейроконтакт",500,0,0,null,[[_standard_cab],[_extra_cab]],"+1 к пилотированию",null,0,[_sg_cockpit,_sg_torso]),
	new MDevice("ортопедич. кресло",500,0,0,null,[[_standard_cab],[_extra_cab]],"+2 спасбросок при дин.перегруз.",null,50,[_sg_cockpit,_sg_torso]),
	new MDevice("охладитель G",
		function(){return this.get_rk()*250;},0,-5,null,null,"лимитированный накопитель тепла",null,
		function(){return this.get_rk()*200;},[_sg_nose,_sg_cockpit,_sg_torso,_sg_tail,_sg_wings,_sg_legs,_sg_hands]),
	new MDevice("охладитель F1",
		function(){return this.get_rk()*500;},0,-2,null,null,"наружний перманентный охладитель",null,
		function(){return this.get_rk()*100;},[_sg_nose,_sg_cockpit,_sg_torso,_sg_tail,_sg_wings,_sg_legs,_sg_hands],
		-1,[[device_allocation_types[1]], device_implementation_types]),
	new MDevice("охладитель F2",
		function(){return this.get_rk()*200;},
		function(){return this.get_rk()/2;},-0.1,null,null,"дополнительное пораундовое охлаждение",null,
		function(){return this.get_rk()*50;},[_sg_nose,_sg_cockpit,_sg_torso,_sg_tail,_sg_wings,_sg_legs,_sg_hands],
		-1,[[device_allocation_types[0]], device_implementation_types]),
	new MDevice("отсек охладителей G и F1", 
		function(){return this.get_rk()*50;},
		function(){return this.get_rk()/2;},0,null,null,"отсек для охладителей",null,0,
		[_sg_nose,_sg_cockpit,_sg_torso,_sg_tail,_sg_wings,_sg_legs,_sg_hands]
	),
	new MDevice("пассажирск./трансп. отсек",100,1,0,null,null,"Пассажирское место\Транспортный отсек",
		null,50,[_sg_nose,_sg_cockpit,_sg_torso,_sg_tail,_sg_wings]
	),
	new MDevice("прыжковый бустер", 
		function(){
			//if(this.device_in_unit(_jumper_boost))return 0;
			return this.get_rk()*1000/this.divider;
		},
		function(){
			var tp = (this.get_rk()-2)*2; 
			tp = tp<1?1:tp;
			return tp/this.divider;
		},
		3, null, null, "позволяет осуществлять прыжки", _all_segments,
		function(){
			//if(this.device_in_unit(_jumper_boost))return 0;
			var tp = (this.get_rk()-2)*300; 
			if(tp<300)return 300/this.divider; else return tp/this.divider;
		},
		[_sg_torso,_sg_legs],1,null,"сопло"
	),
	new MDevice("сис.корректировки управл.",10000,0,0,null,[[_standard_cab],[_extra_cab]],"+1 к пилотированию",null,100,[_sg_cockpit,_sg_torso],1),
	new MDevice("улучш.сис.целенаведения",10000,0,0,null,[[_standard_cab],[_extra_cab]],"+1 к стрельбе",null,100,[_sg_cockpit,_sg_torso],1),
	new MDevice("установка Фриза",
		function(){return this.get_rk()*1000;},
		function(){return this.get_rk()-1;},
		-1,null,null,"охлаждение меха за счет энергозатрат",null,
		function(){return this.get_rk()*250;},
		[_sg_cockpit,_sg_torso]
	),
	new MDevice("ТШ",
		function(){return (this.get_rk()+1)*50;},
		function(){return this.get_rk()-1;},
		0,null,null,"торцевой шарнир",_all_segments,
		function(){return this.get_rk()*100;},
		[_sg_torso],1,
		[torso_degree, [device_allocation_types[0]], device_implementation_types]
	),
	new MDevice("силовая броня",
		function(){return this.get_rk()*500;},
		0,0,null,null,"силовая броня",null,10,
		[_sg_nose,_sg_cockpit,_sg_torso,_sg_hands,_sg_legs,_sg_wheels,_sg_screws,_sg_track,_sg_wings,_sg_tail],
		-1,[]
	),
	new MDevice("динамическая броня",20,0,0,null,null,"динамическая броня",_this_segment,10,
		[_sg_nose,_sg_cockpit,_sg_torso,_sg_hands,_sg_legs,_sg_wheels,_sg_screws,_sg_track,_sg_wings,_sg_tail],
		function(){
			return this.get_rk();
		},[em]
	)
];
//девайсы- name, price, size, warming, installed, controlled_by, description, 
//controlls_area, weight, allowed_segments, max_count, options, composite_name

//пушки name_param, price_param, size_param, warming_param, weight_param, range_param, add_seg_param, add_options

var ri_ap_pu_ao = [range_increase[4],range_increase[0]];
var ri_lp_o = [range_increase[4],range_increase[1]];
var ri_pp = [range_increase[4],range_increase[2],range_increase[3]];

var db_ap_pu_ao = [damage_boost[0],damage_boost[1],damage_boost[2],damage_boost[3],damage_boost[4],damage_boost[5]];
var db_lp = [damage_boost[0],damage_boost[6]];

var weapons = [
	new MWeapon("АП-15",3600,2,0.5,300,7,null,[ri_ap_pu_ao,db_ap_pu_ao,double_ammo]),
	new MWeapon("АП-20",4280,2,0.6,500,6,null,[ri_ap_pu_ao,db_ap_pu_ao,double_ammo]),
	new MWeapon("АП-25",4760,3,0.7,700,5,null,[ri_ap_pu_ao,db_ap_pu_ao,double_ammo]),
	new MWeapon("АП-30",5440,3,0.8,900,4,null,[ri_ap_pu_ao,db_ap_pu_ao,double_ammo]),
	new MWeapon("АП-35",5620,4,0.9,1100,3,null,[ri_ap_pu_ao,db_ap_pu_ao,double_ammo]),
	new MWeapon("ПУ-7.5",2590,1,0.6,200,6,null,[ri_ap_pu_ao,db_ap_pu_ao,double_ammo]),
	new MWeapon("ПУ-12.7",3220,1,1.2,300,7,null,[ri_ap_pu_ao,db_ap_pu_ao,double_ammo]),
	new MWeapon("ПУ-13.5",3880,1,1.8,400,8,null,[ri_ap_pu_ao,db_ap_pu_ao,double_ammo]),
	new MWeapon("ПУ-5.5Ga",3400,1,3.6,500,4,null,[ri_ap_pu_ao,db_ap_pu_ao,double_ammo]),
	new MWeapon("МПО",3200,1,1,300,3,null),
	new MWeapon("БПО",4100,1,1.6,450,4,null),
	new MWeapon("ПО-600",6000,2,2,800,5,null),
	new MWeapon("АО-80",9215,5,1,1500,7,null,[ri_ap_pu_ao,db_ap_pu_ao,double_ammo]),
	new MWeapon("АО-100",9700,6,1.2,1700,6,null,[ri_ap_pu_ao,db_ap_pu_ao,double_ammo]),
	new MWeapon("АО-120",10185,7,1.4,1900,5,null,[ri_ap_pu_ao,db_ap_pu_ao,double_ammo]),
	new MWeapon("АУНС",9595,7,1,2000,8,null,[ri_ap_pu_ao,db_ap_pu_ao,double_ammo]),
	new MWeapon("ПП",3040,3,0,300,2,null,[ri_pp,double_ammo]),
	new MWeapon("БПП",2090,4,0,500,3,null,[ri_pp,double_ammo]),
	new MWeapon("ЛЛП",5985,1,1,300,2,null,[ri_lp_o,db_lp]),
	new MWeapon("СЛП",7455,2,3,400,3,null,[ri_lp_o,db_lp]),
	new MWeapon("ТЛП",8820,3,5,700,4,null,[ri_lp_o,db_lp]),
	new MWeapon("СТЛП",10080,4,7,1100,5,null,[ri_lp_o,db_lp]),
	new MWeapon("МГО",2700,1,0.5,500,8,null,[double_ammo]),
	new MWeapon("БГО",8460,3,0.5,1400,8,null,[double_ammo]),
	new MWeapon("Резак",2500,1,0.7,100,0,_sg_legs),
	new MWeapon("РУ-1",900,1,2,200,5,null,[accuracy_improove]),
	new MWeapon("РУ-3",2900,1,2,400,5,null,[accuracy_improove]),
	new MWeapon("РУ-5",4800,2,2,600,5,null,[accuracy_improove]),
	new MWeapon("РУ-10",9600,3,2,1200,5,null,[accuracy_improove]),
	new MWeapon("РУ-20",19500,5,2,2400,5,null,[accuracy_improove]),
	new MWeapon("ММО",1300,1,0,200,0,_sg_legs),
	new MWeapon("БМО",4100,3,0,500,0,_sg_legs)
];
//батареи и аккумуляторы 
var batteries = [
	new MBattery("A--",		40,		370,	1,	100),
	new MBattery("A-",		45,		420,	1,	100),
	new MBattery("A",		50,		470,	1,	100),
	new MBattery("A+",		55,		520,	1,	100),
	new MBattery("A++",		60,		570,	1,	100),
	new MBattery("B--",		120,	1150,	2,	200),
	new MBattery("B-",		135,	1300,	2,	200),
	new MBattery("B",		150,	1450,	2,	200),
	new MBattery("B+",		165,	1600,	2,	200),
	new MBattery("B++",		180,	1750,	2,	200),
	new MBattery("С--",		240,	2330,	3,	300),
	new MBattery("С-",		270,	2630,	3,	300),
	new MBattery("С",		300,	2930,	3,	300),
	new MBattery("С+",		330,	3230,	3,	300),
	new MBattery("С++",		360,	3530,	3,	300),
	
	new MBattery("Aс--",	40,		975,	1,	100),
	new MBattery("Aс-",		45,		1050,	1,	100),
	new MBattery("Aс",		50,		1175,	1,	100),
	new MBattery("Aс+",		55,		1300,	1,	100),
	new MBattery("Aс++",	60,		1425,	1,	100),
	new MBattery("Bс--",	120,	2875,	2,	200),
	new MBattery("Bс-",		135,	3250,	2,	200),
	new MBattery("Bс",		150,	3625,	2,	200),
	new MBattery("Bс+",		165,	4000,	2,	200),
	new MBattery("Bс++",	180,	4375,	2,	200),
	new MBattery("Сс--",	240,	5825,	3,	300),
	new MBattery("Сс-",		270,	6575,	3,	300),
	new MBattery("Сс",		300,	7325,	3,	300),
	new MBattery("Сс+",		330,	8075,	3,	300),
	new MBattery("Сс++",	360,	8825,	3,	300)
];
//двигло
var engines = [
	new MEngine("Z--", 	320, 	0.1, 	0.5, 	220),
	new MEngine("Z-", 	360, 	0.1, 	0.5, 	260),
	new MEngine("Z", 	400, 	0.1, 	0.5, 	300),
	new MEngine("Z+", 	440, 	0.1, 	0.5, 	340),
	new MEngine("Z++", 	480, 	0.1, 	0.5, 	380),
	new MEngine("S--", 	600, 	0.1, 	1,  	500),
	new MEngine("S-", 	675, 	0.1, 	1,  	575),
	new MEngine("S", 	750, 	0.1, 	1,  	650),
	new MEngine("S+", 	825, 	0.1, 	1,  	725),
	new MEngine("S++", 	900, 	0.1, 	1,  	800),
	new MEngine("A--", 	1810, 	0.2, 	2,  	1610),
	new MEngine("A-", 	2030, 	0.2, 	2,  	1830),
	new MEngine("A", 	2250, 	0.2, 	2,  	2050),
	new MEngine("A+", 	2470, 	0.2, 	2,  	2270),
	new MEngine("A++", 	2690, 	0.3, 	3,  	2390),
	new MEngine("B--", 	3010, 	0.3, 	3,  	2710),
	new MEngine("B-", 	3380, 	0.3, 	3,  	3080),
	new MEngine("B", 	3750, 	0.4, 	4,  	3350),
	new MEngine("B+", 	4120, 	0.4, 	4,  	3720),
	new MEngine("B++", 	4490, 	0.4, 	4,  	4090),
	new MEngine("C--", 	6315, 	0.6, 	6,  	5715),
	new MEngine("C-", 	7095, 	0.7, 	7,  	6395),
	new MEngine("C", 	7875, 	0.8, 	8,  	7085),
	new MEngine("C+", 	8655, 	0.9, 	9,  	7755),
	new MEngine("C++", 	9435, 	0.9, 	9,  	8535),
	new MEngine("S++[s-7k]", 700, 0,	1, 		0)
];

//сплавы: имя, поглощение, теплостойкость, мф. веса, коэф.прочн., массив цен по рк, массив весов
var materials = [
	new MMaterial("алюминий",2,1.5,16,0.8,[5304,6884,9592,12224,15772,19928],[2416,3136,3968,4896,5888,6912]),
	new MMaterial("ал.-сталь",4,2.8,18,1,[7896,10265,13870,17494,22103,27363],[3384,4410,5580,6876,8262,9702]),
	new MMaterial("сталь",6,3.7,20,1.2,[13288,17272,22736,28442,35238,42786],[4520,5880,7440,9180,11020,12940]),
	new MMaterial("стеклопластик",2,2.1,8,0.25,[5435,6945,9585,12160,15660,19695],[752/2,1104/2,1552/2,2212/2,2752/2,3504/2]),
	new MMaterial("пластик",1,1,6,0.3,[5314,6766,9334,11816,15214,19126],[684/2,996/2,1404/2,1896/2,2484/2,3156/2]),
	new MMaterial("авиац. сплав",1,1,11,0.4,[5276,6710,9256,11710,15076,18950],[1672/2,2420/2,3432/2,4620/2,6072/2,7700/2])
];

var armorplates = [ //name; heat_resistance; damage_absorbtion; hit_points; weight;	price;
	new MArmorPlate("пластик",1,1,[4,8,12,16,19,23,27,32],[24,48,72,96,114,138,162,192],
		[8,16,24,32,38,46,54,64]),
	new MArmorPlate("стеклопластик",2.1,2,[4,7,10,13,16,20,23,27],[32,56,80,104,128,160,184,216],
		[24,42,60,78,96,120,138,162]),
	new MArmorPlate("мет./пластик",1.8,3,[12,20,29,37,47,58,69,81],[156,260,377,481,611,754,897,1053],
		[120,200,290,370,470,580,690,810]),
	new MArmorPlate("сталь",3.7,6,[17,31,46,59,75,92,110,129],[340,620,920,1180,1500,1840,2200,2580],
		[646,1178,1748,2242,2850,3496,4180,4902]),
	new MArmorPlate("легир. сталь",3.8,8,[18,34,49,64,81,100,119,140],[378,714,1029,1344,1701,2100,2499,2940],
		[1188,2244,3234,4224,5346,6600,7854,9240]),
	new MArmorPlate("НТС",3.2,13,[21,39,57,74,93,115,137,161],[945,1755,2565,3330,4185,5175,6165,7245],
		[2772,5148,7524,9768,12276,15180,18084,21252]),
	new MArmorPlate("мет./керам.",4.3,14,[13,24,34,45,56,69,82,97],[247,456,646,855,1064,1311,0,0],
		[2587,4776,6766,8955,11144,13731,16318,19303]),
	new MArmorPlate("титан",4.5,15,[22,42,61,79,100,123,147,172],[308,588,854,1106,1400,1722,0,0],
		[5038,9618,13969,18091,22900,28167,33663,39388]),
	new MArmorPlate("С-Х Сплав",5,20,[3,4,6,8,10,12,13,16],[75,100,150,200,250,300,0,0],
		[1329,1772,2658,3544,4430,5316,5759,7088])
];

var armor_shields = [];
var armor_plates_1 = [];
var armor_plates_2 = [];
var armor_plates_3 = [];
for(var i=0;i<armorplates.length;i++){
	armor_plates_1.push(new MDevice(armorplates[i].name,
		function(pl_i){var trk = this.get_rk();	return trk?armorplates[pl_i].price[trk-3]:0;},
		0, 0, null, null, "бронепл.", _this_segment, 
		function(pl_i){var trk = this.get_rk();	return trk?armorplates[pl_i].weight[trk-3]:0; },
		[_sg_nose,_sg_cockpit,_sg_torso,_sg_hands,_sg_legs,_sg_wheels,_sg_screws,_sg_track,_sg_wings,_sg_tail],
		1, [armor_hardering],null,
		function(pl_i){var trk = this.get_rk();	return trk?armorplates[pl_i].hit_points[trk-3]:0; },_armor1
	));
	armor_plates_2.push(new MDevice(armorplates[i].name,
		function(pl_i){var trk = this.get_rk();	return trk?armorplates[pl_i].price[trk-2]:0;},
		0, 0, null, null, "бронепл.", _this_segment, 
		function(pl_i){var trk = this.get_rk();	return trk?armorplates[pl_i].weight[trk-2]:0; },
		[_sg_nose,_sg_cockpit,_sg_torso,_sg_hands,_sg_legs,_sg_wheels,_sg_screws,_sg_track,_sg_wings,_sg_tail],
		1, [armor_hardering],null,
		function(pl_i){var trk = this.get_rk();	return trk?armorplates[pl_i].hit_points[trk-2]:0; },_armor2
	));
	armor_plates_3.push(new MDevice(armorplates[i].name,
		function(pl_i){var trk = this.get_rk();	return trk?armorplates[pl_i].price[trk-1]:0;},
		0, 0, null, null, "бронепл.", _this_segment, 
		function(pl_i){var trk = this.get_rk();	return trk?armorplates[pl_i].weight[trk-1]:0; },
		[_sg_nose,_sg_cockpit,_sg_torso,_sg_hands,_sg_legs,_sg_wheels,_sg_screws,_sg_track,_sg_wings,_sg_tail],
		1, [armor_hardering],null,
		function(pl_i){var trk = this.get_rk();	return trk?armorplates[pl_i].hit_points[trk-1]:0; },_armor3
	));
	
	armor_shields.push(new MDevice(armorplates[i].name, 
		function(pl_i){var trk = this.get_rk();	return trk?armorplates[pl_i].price[trk-3]:0;},
		1, 0, null, null, "щит", _this_segment, 
		function(pl_i){var trk = this.get_rk();	return trk?armorplates[pl_i].weight[trk-3]:0; },
		[_sg_hands],1, [armor_hardering, shield_size],null,
		function(pl_i){var trk = this.get_rk();	return trk?armorplates[pl_i].hit_points[trk-3]:0; },_shield
	));
}

//ходовые
// группы сегментов: 0-нос, 1-винты, 2-крылья, 3-хвост, 4-кокпит, 5-руки, 6-ноги, 7-торс/фюз., 8-колеса, 9-гусеницы*
var allowed_structures = [
	new MStructure("4 колеса",1,_terrestrial,	[0,0,0,0,1,0,0,1,4,0],	{a:0,b:1},{a:1,b:1},0,200,250),
	new MStructure("6 колес",1,_terrestrial,	[0,0,0,0,1,0,0,1,6,0],	{a:0,b:1},{a:1,b:1},0,300,750),
	new MStructure("8 колес",1,_terrestrial,	[0,0,0,0,1,0,0,1,8,0],	{a:0,b:1},{a:1,b:1},0,400,1250),
	new MStructure("10 колес",1,_terrestrial,	[0,0,0,0,1,0,0,1,10,0],	{a:0,b:1},{a:1,b:1},0,600,1750),
	new MStructure("гусеницы",1,_terrestrial,	[0,0,0,0,1,0,0,1,0,2], {a:0,b:-1},{a:1,b:1},0,550,2500),
	new MStructure("шаговая 2-0",1,_terrestrial,[0,0,0,0,1,0,2,1,0,0],	{a:0,b:0},{a:1,b:1},0,150,250),
	new MStructure("шаговая 4-0",1,_terrestrial,[0,0,0,0,1,0,4,1,0,0],	{a:0,b:0},{a:1,b:1},0,300,1250),
	new MStructure("шаговая 6-0",1,_terrestrial,[0,0,0,0,1,0,6,1,0,0],	{a:0,b:0},{a:1,b:1},0,450,2250),
	new MStructure("шаговая 2-2",1,_terrestrial,[0,0,0,0,1,2,2,1,0,0],	{a:0,b:0},{a:1,b:1},2,300,750),
	new MStructure("шаговая 4-2",1,_terrestrial,[0,0,0,0,1,2,4,1,0,0],	{a:0,b:0},{a:1,b:1},2,450,1750),
	new MStructure("шаговая 6-2",1,_terrestrial,[0,0,0,0,1,2,6,1,0,0],	{a:0,b:0},{a:1,b:1},2,600,2750),
	new MStructure("шаговая 2-4",1,_terrestrial,[0,0,0,0,1,4,2,1,0,0],	{a:0,b:0},{a:1,b:1},4,450,1250),
	new MStructure("шаговая 4-4",1,_terrestrial,[0,0,0,0,1,4,4,1,0,0],	{a:0,b:0},{a:1,b:1},4,600,2250),
	new MStructure("шаговая 6-4",1,_terrestrial,[0,0,0,0,1,4,6,1,0,0],	{a:0,b:0},{a:1,b:1},4,750,3250),
	new MStructure("шаговая 2-6",1,_terrestrial,[0,0,0,0,1,6,2,1,0,0],	{a:0,b:0},{a:1,b:1},6,600,1750),
	new MStructure("шаговая 4-6",1,_terrestrial,[0,0,0,0,1,6,4,1,0,0],	{a:0,b:0},{a:1,b:1},6,750,2750),
	new MStructure("шаговая 6-6",1,_terrestrial,[0,0,0,0,1,6,6,1,0,0],	{a:0,b:0},{a:1,b:1},6,900,3750),
	new MStructure("крылья",3,	_aero,			[1,0,1,1,1,0,0,1,0,0],	{a:0,b:0},{a:4,b:4},2,275,500),
	new MStructure("винты",2,	_aero,			[1,1,0,1,1,0,0,1,0,0],	{a:4,b:4},{a:1,b:1},1,100,1500)
];

//модификации- name_param, mcost_param, amount_param, controlled_param, operations_param
var mods = [
	new Modification("теплостойкий контур", 0,[
		new MOperation(_summation,0,"Увеличение безопасного нагрева",[_safety_warming],false,
			function(){
				return this.get_rk();
			}),
		new MOperation(_summation,0,"Занимаемое место",[_occ_capacity],false,
			function(){
				return this.get_rk();
			}),
		new MOperation(_summation,0,"Вес",[_total_weight],false,
			function(){
				return this.get_rk()*100*this.get_weight_multiplier();
			}),
		new MOperation(_summation,0,"Цена",[_total_unit_price],false,
			function(){
				return this.get_rk()*1000;
			})
	]),
	new Modification("изменить порог перегрева", 0, [
		new MOperation(_replacement,5,"Пороговое значение блокиратора",[_control_lock_threshold],_user_input)
	]),
	new Modification("спец-заказ",0,[
		new MOperation(_replacement,1,"Изготовляемая вместимость",[_total_capacity],_user_input,
			function(trk_p){
				var trk = trk_p?trk_p:this.get_rk(); //alert(trk);
				var tdc2 = mods[_special_order].operations[0].value;
				if(trk>2){
					var tsc2 = capacities[trk-3];
					var tub = tsc2 + trk;
					var tlb = lower_capacity_limit[trk-3]; 
					if (tdc2<tlb || tdc2>tub){
						return tsc2;
					}
				}
				return tdc2;
			}),
		new MOperation(_multiplication,1,"Коэф.изменения хитов в сегменте",[_segments_hp,_hands_hp,_legs_hp],false,
			function(){
				var trk = this.get_rk(); trk=trk?trk:0;
				var tdc = mods[_special_order].operations[0].value_function.call(null,trk);
				var tsc = trk>2?capacities[trk-3]:tdc; 
				return 2-tdc/tsc;
			}),
		new MOperation(_replacement,0,"Новый вес корпуса",[_material_weight],false,
			function(){
				var tk = mods[_special_order].operations[1].value;
				var tsh = this.attr[_segments_hp].value;
				var tvm = this.material?this.material.attr[_weight_modifier].value:0; 
				var nc = Math.ceil(tk*tsh)*tvm;
				return nc;
			}),
		new MOperation(_multiplication,1,"Коэф.изменения цены корпуса",[_material_cost],false,
			function(){
				var trk = this.get_rk(); trk=trk?trk:0;
				var tdc = mods[_special_order].operations[0].value_function.call(null,trk); 
				var tsc = trk>2?capacities[trk-3]:tdc; 
				return 1+Math.abs(tsc-tdc)/100;
			})
	]),
	new Modification("ОМНИ",0,[
		new MOperation(_multiplication,0.9,"Коэф.изменения хитов в сегменте",[_segments_hp,_hands_hp,_legs_hp]),
		new MOperation(_multiplication,1.2,"Коэф.изменения стоимости корпуса",[_material_cost])
	]),
	new Modification("изменить на каркасный",0,[
		new MOperation(_multiplication, 0.5, "Коэф.изменения хитов в сегменте",[_segments_hp,_hands_hp,_legs_hp]), 
		new MOperation(_multiplication, 0.5, "Коэф.изменения веса корпуса",[_material_weight]),
		new MOperation(_multiplication, 0.75, "Коэф.изменения стоимости корпуса",[_material_cost])
	]),/*
	new Modification("расточка корпуса",0,[
		new MOperation(_replacement,1,"величина расточки",[],_user_input),
		new MOperation(_summation,0,"добавочная вместимость",[_total_capacity],false,
			function(){
				var tbv = mods[_boring].operations[0].value;
				var trk = this.attr[_rk].value;
				if(tbv>=1 && tbv<=3 && trk>2){
					return (tbv + 2*trk - 5)*tbv/2;
				}else return 0;
			}),
		new MOperation(_multiplication,1,"коэф.изменения веса корпуса",[_material_weight],false,
			function(){
				var tbv = mods[_boring].operations[0].value;
				var trk = this.attr[_rk].value;
				if(tbv>=1 && tbv<=3 && trk>2){
					return (1-(tbv+1)*tbv*0.025);
				}else return 1;
			}),
		new MOperation(_multiplication,1,"коэф.изменения хитов корпуса",[_segments_hp,_hands_hp,_legs_hp],false,
			function(){
				var tbv = mods[_boring].operations[0].value;
				var trk = this.attr[_rk].value;
				if(tbv>=1 && tbv<=3 && trk>2){
					return (1-(tbv+1)*tbv*0.025);
				}else return 1;
			}),
		new MOperation(_summation,0,"стоимость расточки",[_material_cost],false,
			function(){
				var trk = this.attr[_rk].value;
				var tbv = mods[_boring].operations[0].value;
				if(tbv>=1 && tbv<=3 && trk>2){
					var tbc = (10-trk)*500*tbv;
					//mods[_boring].cost = tbc;
					return tbc;
				}else {
					mods[_boring].cost = 0;
					return 0;
				}
			})
	])*/
	new Modification("расточка корпуса-1",0,[
		new MOperation(_summation,0,"добавочная вместимость",[_total_capacity],false,
			function(){
				var trk = this.attr[_rk].value;
				if(trk>2) return trk - 2;
				else return 0;
			}),
		new MOperation(_multiplication,1,"коэф.изменения веса корпуса",[_material_weight],false,
			function(){
				var trk = this.attr[_rk].value;
				if(trk>2) return 0.95;
				else return 1;
			}),
		new MOperation(_multiplication,1,"коэф.изменения хитов корпуса",[_segments_hp,_hands_hp,_legs_hp],false,
			function(){
				var trk = this.attr[_rk].value;
				if(trk>2) return 0.95;
				else return 1;
			}),
		new MOperation(_summation,0,"стоимость расточки",[_material_cost],false,
			function(){
				var trk = this.attr[_rk].value;
				if(trk>2){
					var tbc = (10-trk)*500;
					return tbc;
				}else {
					mods[_boring].cost = 0;
					return 0;
				}
			})
	]),
	new Modification("расточка корпуса-2",0,[
		new MOperation(_summation,0,"добавочная вместимость",[_total_capacity],false,
			function(){
				var trk = this.attr[_rk].value;
				if(trk>2) return trk - 1;
				else return 0;
			}),
		new MOperation(_multiplication,1,"коэф.изменения веса корпуса",[_material_weight],false,
			function(){
				var trk = this.attr[_rk].value;
				if(trk>2) return 0.90;
				else return 1;
			}),
		new MOperation(_multiplication,1,"коэф.изменения хитов корпуса",[_segments_hp,_hands_hp,_legs_hp],false,
			function(){
				var trk = this.attr[_rk].value;
				if(trk>2) return 0.90;
				else return 1;
			}),
		new MOperation(_summation,0,"стоимость расточки",[_material_cost],false,
			function(){
				var trk = this.attr[_rk].value;
				if(trk>2){
					var tbc = (10-trk)*500;
					return tbc;
				}else {
					mods[_boring].cost = 0;
					return 0;
				}
			})
	]),
	new Modification("расточка корпуса-3",0,[
		new MOperation(_summation,0,"добавочная вместимость",[_total_capacity],false,
			function(){
				var trk = this.attr[_rk].value;
				if(trk>2) return trk;
				else return 0;
			}),
		new MOperation(_multiplication,1,"коэф.изменения веса корпуса",[_material_weight],false,
			function(){
				var trk = this.attr[_rk].value;
				if(trk>2) return 0.85;
				else return 1;
			}),
		new MOperation(_multiplication,1,"коэф.изменения хитов корпуса",[_segments_hp,_hands_hp,_legs_hp],false,
			function(){
				var trk = this.attr[_rk].value;
				if(trk>2) return 0.85;
				else return 1;
			}),
		new MOperation(_summation,0,"стоимость расточки",[_material_cost],false,
			function(){
				var trk = this.attr[_rk].value;
				if(trk>2){
					var tbc = (10-trk)*500;
					return tbc;
				}else {
					mods[_boring].cost = 0;
					return 0;
				}
			})
	])
];
