﻿function MUnitBuilder(default_devices_param,device_dependences_param) {
	//переданные параметры
	this.default_devices_map=default_devices_param;
	this.device_dependences = device_dependences_param;

	//индексирование
	this.device_settings = [];
	/*строковый индекс = индекс типа девайса + номер девайса данного типа в модели,
	значение = клон девайса*/
	
	this.modifications = new Array(mods.length);
	/*индекс = индексу модификации в dataset.mods, а значение = true/false (вкл/выкл)*/
	
	this.device_counter = [];
	/*индекс в массиве = индексу девайса в dataset.
	В качестве данных - число установок данного девайса без учета удалений минус 1*/
	
	this.seg_group_mapper = false;
	/*индекс = номеру группы сегмента, а значение -
	массив индексов из this.segments*/
		
	this.devices_mapper = [];
	/*индекс в массиве = индексу девайса в dataset.
	В качестве данных - массив ссылок на сегменты в 
	this.segments, в которых установлен данный девайс.
	Если девайсов данного вида в данном сегменте несколько, 
	то ссылка на сегмент вписывается соответствующее число раз*/
	this.devices_mapper_2 = [];
	/*индекс в массиве = индексу девайса в dataset.
	В качестве данных - массив ссылок на клоны объектов 
	соотв-х девайсов в this.device_settings*/
	this.bmd_accord = [];
	//набор объектов с двумя аттрибутами: 
	//gen_lnk - индекс генератора из this.device_settings ;
	//engines_arr - массив индексов движков из this.device_settings, к которым подключен выбранный генератор ;
	
	//атрибуты модели
	this.divider = 1;
	this.selected_segment_index = -1;
	this.structure = false;
	this.material = false; 
	this.segments = [];
	this.attr = [
		new Attribute("название",false), 
		new Attribute("РК",false), 
		new Attribute("шаговая скорость",0),
		new Attribute("скорость бегом",0), 
		new Attribute("безопасный нагрев",false), 
		new Attribute("пороговое значение блокиратора",5),
		new Attribute("рабочая нагрузка двигателей",0),
		new Attribute("полный вес",0),
		new Attribute("свободный вес",0),//разница между мощн.движков и полным весом
		new Attribute("вместимость",0),
		new Attribute("места занято",0),
		new Attribute("общая стоимость сборки",0),
		new Attribute("хитов в сегменте",0),
		new Attribute("хитов в руке",0),
		new Attribute("хитов в ноге",0),
		new Attribute("ступень мощности",0), //_power_threshold
		new Attribute("коэф.веса",1), //в завис. от типа тех.
		new Attribute("стоимость всех модификаций",0),
		new Attribute("стоимость всех девайсов",0),
		new Attribute("вес корпуса",0),
		new Attribute("стоимость корпуса",0),
		new Attribute("вес всех девайсов",0),
		new Attribute("массированный урон",0),
		new Attribute("суммарный энергозапас",0),
		new Attribute("БМД",0)
	];
	
	//init modifiable attributes
	for(var i=0;i<mods.length;i++){
		var tmo = mods[i].operations;
		for(var j=0;j<tmo.length;j++){
			var tma = tmo[j].modified_attributes;
			for(var k=0;k<tma.length;k++){
				this.attr[tma[k]].controlled_by_operations.push(new OperationMapper(i,j));
			}
		}
	}
}

//setters 
MUnitBuilder.prototype.share_hit_points = function(){//alert('распределение хитов');
	var tsh = this.get_seg_hp();
	var thh = this.get_hand_hp();
	var tlh = this.get_leg_hp();
	var tsh2 = Math.ceil(tsh/2);
	for(var i=0;i<this.segments.length;i++){
		switch(this.segments[i].attr[_segment_group].value){
			case _sg_hands:
				this.segments[i].attr[_segment_hp].value = thh;
				break;
			case _sg_legs: case _sg_wheels:
				this.segments[i].attr[_segment_hp].value = tlh;
				break;
			case _sg_wings: case _sg_screws:
				this.segments[i].attr[_segment_hp].value = tsh2;
				break;
			default:
				this.segments[i].attr[_segment_hp].value = tsh;
				break;
		}
	}
}
MUnitBuilder.prototype.calc_hit_points = function(){
	var trk = this.get_rk();
	if(this.structure && this.material && trk>2){
		var rki = rk_consts[trk-3];
		var mdf = this.material.attr[_durability_factor].value; 
		var hn=this.structure.config[_sg_hands]; 
		var ln=this.structure.config[_sg_legs]>0?this.structure.config[_sg_legs]:this.structure.config[_sg_wheels];
		
		this.attr[_segments_hp].value= Math.ceil(mdf*Math.ceil(rki/(5+trk)));
		var tshp = this.attr[_segments_hp].value;
		this.attr[_hands_hp].value = hn>2 ? Math.ceil(mdf*Math.ceil(rki/(5+trk+hn-2))) : tshp;
		this.attr[_legs_hp].value = ln>2 ? Math.ceil(mdf*Math.ceil(rki/(5+trk+ln-2))) : tshp;
		this.share_hit_points();
		return true;
	}
	return false;
}
MUnitBuilder.prototype.change_battery_load = function(addendum_param){
	this.attr[_total_battery_load].value +=addendum_param;
}
MUnitBuilder.prototype.change_engines_workload = function(addendum_param){
	this.attr[_engines_workload].value +=addendum_param;
	this.set_power_threshold();
	this.calc_vacant_weight(); 
}
MUnitBuilder.prototype.set_weight = function(){
	var trk = this.get_rk();
	var rk_w = 0;
	var struct_w = 0;
	if(trk>2 && this.material) {
		this.attr[_material_weight].value = this.material.weights[trk-3];
		rk_w = this.get_material_weight();
	}
	if(trk>2 && this.structure)
		struct_w = this.structure.attr[_struct_weight_factor].value*trk;
	this.attr[_total_weight].value = (rk_w + struct_w + this.get_all_devices_weight())*this.get_weight_multiplier();
	this.calc_vacant_weight();
}
MUnitBuilder.prototype.change_weight = function(addendum_param){
	if(addendum_param!=0){
		this.attr[_total_weight].value += (addendum_param*this.get_weight_multiplier()); 
		this.calc_vacant_weight();
	}
}
MUnitBuilder.prototype.calc_vacant_weight = function(){
	this.attr[_vacant_weight].value = this.get_engines_workload()-this.get_total_weight();
	this.set_speed();
	this.set_massive_damage();
}
MUnitBuilder.prototype.set_total_capacity = function(){
	var trk = this.get_rk();
	if(trk>2) this.attr[_total_capacity].value = capacities[trk-3];
}
MUnitBuilder.prototype.take_place = function(addendum_param){
	this.attr[_occ_capacity].value+=addendum_param;
}
MUnitBuilder.prototype.set_massive_damage = function(){
	var trk = this.get_rk();
	var ttw = this.get_total_weight();
	if(trk>2) {
		this.attr[_massive_damage].value = Math.ceil(ttw/100);
	}
}
MUnitBuilder.prototype.raise_total_price = function(margin_param){
	this.attr[_total_unit_price].value += margin_param;
}
MUnitBuilder.prototype.set_total_price = function(){
	var trk = this.get_rk();
	var rk_cost = 0;
	var structure_cost = 0;
	if(trk>2 && this.material) {
		this.attr[_material_cost].value = this.material.prices[trk-3];
		rk_cost = this.get_material_cost();
	}
		
	if(trk>2 && this.structure)
		structure_cost = this.structure.attr[_struct_price_factor].value*trk;
		
	this.attr[_total_unit_price].value = rk_cost + structure_cost + this.get_all_devices_cost() + this.get_all_mods_cost();
}

MUnitBuilder.prototype.select_segment = function(segment_idx_param){
	var t=this.selected_segment_index;
	this.selected_segment_index = (t==segment_idx_param)?-1:segment_idx_param;
	return t;
}

MUnitBuilder.prototype.set_power_threshold = function(){
	this.attr[_power_threshold].value = this.get_engines_workload()/5;
}
MUnitBuilder.prototype.set_speed = function(){
	var rk_param = this.get_rk();
	var ew = this.get_engines_workload();
	if(ew>0 && rk_param>2 && this.structure){
		var tw = this.get_total_weight();
		var vw = this.get_vacant_weight();
		var pt = this.get_power_threshold(); 
		var asb = pt>0?Math.floor(Math.abs(vw/pt)):0;
		var sb = vw<0?-1*asb:(asb>2?2:asb);
		
		this.attr[_walking_speed].value = 
			basic_speed[rk_param-3] * this.structure.attr[_speed_multiplier].value.a 
			+ this.structure.attr[_speed_modifier].value.a
			+ sb;
		this.attr[_run_speed].value = 
			(basic_speed[rk_param-3]+ basic_speed_boost) * this.structure.attr[_speed_multiplier].value.b
			+ this.structure.attr[_speed_modifier].value.b
			+ ((ew>=tw*3)?2:((ew>=tw*2)?1:0))
			+ sb;
		var _asm = this.structure.additional_speed_mod;
		if(_asm instanceof Function) _asm.call(this);
		return true;
	}else{
		this.attr[_walking_speed].value = 0;
		this.attr[_run_speed].value = 0;
	return false;}
}

MUnitBuilder.prototype.set_modification = function(mod_idx_param){
	this.modifications[mod_idx_param] = !this.modifications[mod_idx_param];
	//стоимость мода
	var onoff = this.modifications[mod_idx_param]?1:-1;
	var ta = mods[mod_idx_param].cost * onoff;
	if (ta!=0){
		this.raise_total_price(ta);
		this.attr[_all_mods_cost].value += ta;
	}
	//применение мода
	var tmo = mods[mod_idx_param].operations;
	for(var i=0;i<tmo.length;i++){ //перебор операций
		var tma = tmo[i].modified_attributes; //alert('new операция '+i);
		for (var j=0;j<tma.length;j++) { //перебор модифицируемых атрибутов
			switch(tma[j]){
				case _segments_hp: case _hands_hp: case _legs_hp:
					this.share_hit_points();
					break; 
				case _material_weight: //case _total_weight:
					this.set_weight();
					break;
				case _material_cost:
					this.set_total_price();
					break;
				
				case -1:
					break;
			}
		}
	}
}
MUnitBuilder.prototype.get_operation_result = function(op_param,value_param){
	var tmo = op_param;
	var result;
	if(tmo.value_function) tmo.value = tmo.value_function.call(this);
	switch(tmo.type){
		case _multiplication:
			result = Math.ceil(value_param * tmo.value);
			break;
		case _summation:
			result = value_param + tmo.value;
			break;
		case _replacement:
			result = tmo.value;
			break;
	}
	return result;
}
MUnitBuilder.prototype.check_modification_of = function(attr_idx_param){
	var atb = this.attr[attr_idx_param];
	var result = atb.value;
	var tcm = atb.controlled_by_operations; 
	if(tcm.length>0) for(var i=0;i<tcm.length;i++) if(this.modifications[tcm[i].mod]){ //перебор контроллирующих модов 
		var tmo = mods[tcm[i].mod].operations[tcm[i].operation];
		result = this.get_operation_result(tmo,result);
	}
	return result;
}

MUnitBuilder.prototype.append_segment = function(group_param, segment_param){
	this.segments.push(segment_param);
	var si = this.segments.length-1;
	if(this.seg_group_mapper[group_param]){
		this.seg_group_mapper[group_param].push(si);
	}else{
		this.seg_group_mapper[group_param]=[si];
	}
}

MUnitBuilder.prototype.build_segments = function(){
	var tts = this.structure;
	if(tts){
		var tsh = this.get_seg_hp();
		var thh = this.get_hand_hp();
		var tlh = this.get_leg_hp();
		var tsh2 = Math.ceil(tsh/2);
		var tmp=(tts.tech_type==_aero)?"Ф":"Т"; 
		var ttsc = tts.config;
		var tci = ttsc[0] + ttsc[1]*2 + ttsc[2]*2 + ttsc[3]; //индекс кокпита
		var tcti = tci + ttsc[4] + ttsc[5] + ttsc[6] + 1; //индекс центр. торса
		var tlti = tcti - 1; //индекс левого торса
		var trti = tcti + 1; //индекс правого торса
		for(var i=0;i<ttsc.length;i++){
			if(ttsc[i]>0){
				var tmp2 = ttsc[i]<=2;
				switch(i){
					case _sg_nose: 
						this.append_segment(i,new MSegment("Нос",i,tsh,tci)); 
						break;
					case _sg_cockpit:
						this.append_segment(i,new MSegment("Кокпит",i,tsh,tcti));
						break;
					case _sg_torso:
						this.append_segment(i,new MSegment("Л"+tmp,i,tsh,tcti));
						this.append_segment(i,new MSegment("Ц"+tmp,i,tsh,-1));
						this.append_segment(i,new MSegment("П"+tmp,i,tsh,tcti));
						break;
					case _sg_hands:
						for(var j=0; j<ttsc[i];j++){
							var lor = (j%2==0);
							this.append_segment(i,new MSegment((lor?'Л':'П')+"P"+(tmp2?'':(Math.floor(j/2)+1)),i,thh,(lor?tlti:trti)));
						}
						break;
					case _sg_legs:
						for(var j=0; j<ttsc[i];j++){
							var lor = (j%2==0);
							this.append_segment(i,new MSegment((lor?'Л':'П')+"H"+(tmp2?'':(Math.floor(j/2)+1)),i,tlh,tcti));
						}
						break;
					case _sg_wheels:
						for(var j=0; j<ttsc[i];j++){
							var lor = (j%2==0);
							this.append_segment(i,new MSegment((lor?'Л':'П')+"K"+(tmp2?'':(Math.floor(j/2)+1)),i,tlh,tcti));
						}
						break;
					case _sg_screws:
						this.append_segment(i,new MSegment("HB",i,tsh2,tcti));
						this.append_segment(i,new MSegment("MB",i,tsh2,tci-1));
						break;
					case _sg_track:
						for(var j=0; j<ttsc[i];j++){
							var lor = (j%2==0);
							this.append_segment(i,new MSegment((lor?'Л':'П')+"Г"+(tmp2?'':(Math.floor(j/2)+1)),i,tsh,tcti));
						}
						break;
					case _sg_wings:
						this.append_segment(i,new MSegment("ЛКp",i,tsh2,tlti));
						this.append_segment(i,new MSegment("ПКp",i,tsh2,trti));
						break;
					case _sg_tail:
						this.append_segment(i,new MSegment("Хвост",i,tsh,tcti));
						break;
				}
			}
		}
	}
}

MUnitBuilder.prototype.set_safety_warming = function(){
	if(this.material && this.attr[_rk].value){
		this.attr[_safety_warming].value = 7 + this.attr[_rk].value + this.material.attr[_heat_conductivity].value;
		return true;
	}else return false;
}
MUnitBuilder.prototype.set_name = function(name_param){
	this.attr[_name].value = name_param;
}
MUnitBuilder.prototype.set_structure = function(structure_index_param){
		this.segments = [];
		this.devices_mapper = [];
		this.devices_mapper_2 = [];
		this.seg_group_mapper = [];
		this.device_counter = [];
		this.device_settings = [];
		this.bmd_accord = [];
		this.attr[_all_devices_cost].value = 0;
		this.attr[_all_devices_weight].value = 0;
		this.attr[_occ_capacity].value = 0;
		this.attr[_power_threshold].value = 0;
		this.attr[_engines_workload].value = 0;
		this.attr[_run_speed].value = 0;
		this.attr[_walking_speed].value = 0;
		this.attr[_material_weight].value = 0;
		this.attr[_material_cost].value = 0;
		this.attr[_total_battery_load].value = 0;
		this.attr[_bmd].value = 0;
	var trk =this.get_rk();
	this.structure = allowed_structures[structure_index_param];
	
	var t = (this.structure.tech_type==_aero)?0:2;
	if(trk>2 && this.structure) {this.take_place(this.structure.attr[_struct_capacity_factor].value*(trk-t));}
	
	this.attr[_weight_multiplier].value = this.structure.tech_type==_terrestrial?1:2;
	this.build_segments();
	this.calc_hit_points();
	this.set_weight();
	this.set_total_price();
	this.set_total_capacity(); 
}

MUnitBuilder.prototype.set_rk = function(rk_value_param){
	var trk = this.get_rk();
	if(trk!=rk_value_param){
		var tscf = this.structure?this.structure.attr[_struct_capacity_factor].value:null;
		var t = (this.structure.tech_type==_aero)?0:2;
		
		if(trk>2 && this.structure) this.take_place(-tscf*(trk-t));
		this.attr[_rk].value = rk_value_param;
		if(rk_value_param>2 && this.structure) this.take_place(tscf*(rk_value_param-t));
		
		this.recalc_devices_attrs();
		this.set_safety_warming();
		this.set_total_capacity();
		this.calc_hit_points();
		this.set_weight();
		this.set_total_price();
	}
}
MUnitBuilder.prototype.set_material = function(material_index_param){
	this.material = materials[material_index_param];
	this.set_safety_warming();
	this.calc_hit_points();
	this.set_weight();
	this.set_total_price();
}
MUnitBuilder.prototype.update_bmd = function(addendum_p){
	this.attr[_bmd].value += addendum_p;
	var tga = [_g1,_g2];
	for(var i=0;i<tga.length;i++){
		var tcda = this.devices_mapper_2[tga[i]];
		if(tcda) for(var j in tcda) if (tcda.hasOwnProperty(j)) { //for(var j=0;j<tcda.length;j++){ 
			var tcgi = tcda[j];
			this.update_device_setting(tga[i], tcgi);
		}
	}
}
MUnitBuilder.prototype.recalc_devices_attrs = function(new_rk_p){
	var tdm2 = this.devices_mapper_2;
	for(var i in tdm2) if (tdm2.hasOwnProperty(i)){ //for(var i=0;i<tdm2.length;i++){
		var tadd = tdm2[i];
		for(var j in tadd) if (tadd.hasOwnProperty(j)){
			var tdoi = tadd[j];
			this.update_device_setting(i,tdoi);
		}
	}
}
MUnitBuilder.prototype.update_device_setting = function(device_index_param, dev_set_idx_p, op_type_idx_p, sel_op_idx_p){
	//взять установленный клон девайса в модели
	var tdo = this.device_settings[dev_set_idx_p]; 
	
	if(tdo){
		var seg_idx_p = tdo.segment_index;
		
		//удалить из модели старые параметры девайса
		this.apply_devices_attributes(tdo, device_index_param, _removing, seg_idx_p); 
		
		//установить новое значение опции
		if(op_type_idx_p!=null && sel_op_idx_p!=null)
			tdo.selected_options[op_type_idx_p] = sel_op_idx_p; 
		
		//создать временный дефолтный клон девайса для модификации
		var tdd = this.get_default_device_object(device_index_param);
		var tmp_device = tdd.clone(seg_idx_p);
		var tadp = get_original_device_index(device_index_param);
		this.update_functional_attributes(tmp_device, tdd, tadp);

		//модифицировать временный клон в соответствии с опциями
		for(var i=0; i<tdo.options.length; i++){
			var j = tdo.selected_options[i]; 
			var too = tdo.options[i][j]; 
			if(too.behavior) {
				too.behavior.call(null, tmp_device, tdd);
			}
		}
		
		//записать модифицированный клон как установленный девайс
		tmp_device.selected_options = tdo.selected_options;
		tdo = tmp_device;
		this.device_settings[dev_set_idx_p] = tmp_device;
		
		//внести глобальные изменения в модель
		this.apply_devices_attributes(tdo, device_index_param, _installing, seg_idx_p); 
	}
}
MUnitBuilder.prototype.apply_devices_attributes = function(device_param, _device_link_param, applying_type_param, _seg_link_param){
	var tm = applying_type_param==_removing?-1:1;
	var td = device_param;
	
	if (td!=false) {
		var tcost = td.attr[_price].value*tm;
		var tcap = td.attr[_size].value*tm; //make_multiple_to(td.attr[_size].value*tm,0.5); 
		var theat = td.attr[_warming].value*tm;
		var tweight = td.attr[_weight].value*tm;
		
		switch(this.get_device_type(_device_link_param)){
			case _engine:
				var ted = engines[_device_link_param - devices.length];
				var tew = ted.attr[_workload].value;
				var tec = ted.device.attr[_size].value;
				var tf = (this.structure.tech_type==_aero);
				var tdow = (tf?tec*100:0) + (td.selected_options[1]==1?(tf?tec*50:tec*25):0);
				this.update_bmd(tm * tec);
				this.change_engines_workload(tm * (tew - tdow));
				break;
			case _battery:
				var tbi = _device_link_param - devices.length - engines.length;
				this.change_battery_load(tm * batteries[tbi].attr[_workload].value);
				break;
		}
		
		if(tweight!=0){
			this.attr[_all_devices_weight].value += tweight;
			this.change_weight(tweight);
		}
		if(theat!=0){
			
		}
		if (tcap!=0) {
			this.take_place(tcap); 
			this.segments[_seg_link_param].attr[_occ_place].value += tcap;
		}
		if (tcost!=0) {
			this.attr[_all_devices_cost].value += tcost;
			this.raise_total_price(tcost);
		}
	}
}

MUnitBuilder.prototype.update_functional_attributes = function(cur_dev_p, def_dev_p,additional_param){
	//если некоторые параметры девайса - функции, вычислить 
	for(var i=0; i<def_dev_p.attr.length; i++){ 
		var tat = def_dev_p.attr[i].value;
		if(typeof(tat)=="function") cur_dev_p.attr[i].value = tat.call(this,additional_param);
	}
}

MUnitBuilder.prototype.install_device = function(_device_link_param,_seg_link_param){
	if (this.device_counter[_device_link_param]>-1){ 
		this.device_counter[_device_link_param]++;
	}else{
		this.device_counter[_device_link_param] = 0; //alert(this.device_counter);
	}
	
	var td = this.get_default_device_object(_device_link_param);
	var tcd = '' + _device_link_param + this.device_counter[_device_link_param];
	
	if(!this.devices_mapper_2[_device_link_param]) this.devices_mapper_2[_device_link_param] = [];
	this.devices_mapper_2[_device_link_param].push(tcd);
	
	this.device_settings[tcd] = td.clone(_seg_link_param);
	for(var i=0;i<td.options.length;i++){
		this.device_settings[tcd].selected_options.push(0);
	}
	var tadp = get_original_device_index(_device_link_param);
	this.update_functional_attributes(this.device_settings[tcd], td, tadp);
	this.apply_devices_attributes(this.device_settings[tcd], _device_link_param, _installing, _seg_link_param);
	
	if(this.device_in_unit(_device_link_param)) {
		this.devices_mapper[_device_link_param].push(_seg_link_param);
	}else{
		this.devices_mapper[_device_link_param]=[_seg_link_param];
	}
	
	return this.device_counter[_device_link_param];
}

//remover
MUnitBuilder.prototype.remove_device_from_segment = function(device_index_param,segment_index_param,tcd_param){
	var t = this.devices_mapper[device_index_param]; 
	
	var segment_pos; 
	for(var i=0;i<t.length && !segment_pos;i++) if(t[i]==segment_index_param) segment_pos=i;
	
	if (segment_pos>-1 && t.length>1) t.splice(segment_pos,1);
	else this.devices_mapper[device_index_param] = _undefined;
	
	var tdo = this.device_settings[tcd_param];
	this.apply_devices_attributes(tdo, device_index_param, _removing, segment_index_param);
	this.device_settings[tcd_param] = null;
	this.bmd_accord[tcd_param] = null;
}

//testers
MUnitBuilder.prototype.get_device_amount_in_segment = function(dev_idx_param,seg_idx_param){
	var t=this.devices_mapper[dev_idx_param];
	var result=0;
	if(this.device_in_unit(dev_idx_param)) 
		for(var i in t) if (t.hasOwnProperty(i)) //for(var i=0;i<t.length;i++) 
			if(t[i]==seg_idx_param) result++;
	return result;
}
MUnitBuilder.prototype.device_in_segment = function(seg_idx_param,dev_idx_param){
	var t=this.devices_mapper[dev_idx_param];
	var result=false;
	if(this.device_in_unit(dev_idx_param))
		for(var i in t) if (t.hasOwnProperty(i)) //for(var i=0;i<t.length && !result;i++)
			if(t[i]==seg_idx_param) 
				result = true;
	return result;
}
MUnitBuilder.prototype.device_in_unit = function(dev_idx_param){
	var t=this.devices_mapper[dev_idx_param];
	if(t && t.length>0) return true;
	else return false;
}
MUnitBuilder.prototype.is_mod_toggled = function(mod_idx_param){
	return this.modifications[mod_idx_param];
}
MUnitBuilder.prototype.are_there_same_controllers = function(controller_idx_param, seg_idx_param){
	var j = controller_idx_param;
	var controlls_all_segments = devices[j].controlled_area==_all_segments;
	var controlls_this_segment = devices[j].controlled_area==_this_segment;
	return ((controlls_all_segments && this.device_in_unit(j)) 
		||(controlls_this_segment && this.device_in_segment(seg_idx_param,j)));
}

MUnitBuilder.prototype.is_the_device_functional = function(dev_p, seg_idx_p){
	var td = dev_p.controlled_by_devices;
	var functional = false;
	if(td) for(var i=0; i<td.length && !functional; i++){
		var tf = true;
		for(var j=0; j<td[i].length && tf; j++){
			if (!this.are_there_same_controllers(td[i][j],seg_idx_p)) tf = false;
		}
		functional = functional || tf;
	}else functional = true;
	return functional;
}

//getters 
MUnitBuilder.prototype.get_default_device_object = function(_device_link_param){
	var tdt = this.get_device_type(_device_link_param);
	var tadp = get_original_device_index(_device_link_param);
	var tdo = false;
	switch(tdt){
		case _device: tdo  = devices[tadp];	break;
		case _engine: tdo  = engines[tadp].device; break;
		case _battery: tdo  = batteries[tadp].device; break;
		case _weapon: tdo  = weapons[tadp].device; break;
		case _armor1: tdo  = armor_plates_1[tadp]; break;
		case _shield: tdo  = armor_shields[tadp]; break;
		case _armor2: tdo  = armor_plates_2[tadp]; break;
		case _armor3: tdo  = armor_plates_3[tadp]; break;
	}
	return tdo;
}
MUnitBuilder.prototype.get_occupied_capacity = function(){
	return this.check_modification_of(_occ_capacity); //this.attr[_occ_capacity].value;
}
MUnitBuilder.prototype.get_total_price = function(){
	return this.check_modification_of(_total_unit_price); //this.attr[_total_unit_price].value;
}
MUnitBuilder.prototype.get_total_capacity = function(){
	return this.check_modification_of(_total_capacity);
}
MUnitBuilder.prototype.get_run_speed = function(){
	return this.attr[_run_speed].value;
}
MUnitBuilder.prototype.get_walking_speed = function(){
	return this.attr[_walking_speed].value;
}
MUnitBuilder.prototype.get_vacant_weight = function(){
	return this.attr[_vacant_weight].value;
}
MUnitBuilder.prototype.get_total_weight = function(){
	return this.check_modification_of(_total_weight); //this.attr[_total_weight].value;
}
MUnitBuilder.prototype.get_engines_workload = function(){
	return this.attr[_engines_workload].value;
}
MUnitBuilder.prototype.get_devices_controlled_by = function(dev_idx_param){
	return this.device_dependences[dev_idx_param];
}
MUnitBuilder.prototype.get_segments_with_device = function(dev_idx_param){
	return this.devices_mapper[dev_idx_param];
}
MUnitBuilder.prototype.get_structure_type = function(){
	return this.structure?this.structure.attr[_name].value:'-';
}
MUnitBuilder.prototype.get_rk = function(){
	return this.attr[_rk].value;
}
MUnitBuilder.prototype.get_material_type = function(){
	return this.material?this.material.attr[_name].value:'-';
}
MUnitBuilder.prototype.get_safety_warming = function(){
	return this.check_modification_of(_safety_warming); //this.attr[_safety_warming].value;
}
MUnitBuilder.prototype.get_name = function(){
	return this.attr[_name].value;
}
MUnitBuilder.prototype.get_control_lock_threshold = function(){
	var tv = this.check_modification_of(_control_lock_threshold);
	var tsw = this.get_safety_warming();
	var tmp_value = this.device_in_unit(_control_lock_device)?(tsw?tsw + tv:""):" - ";
	return tmp_value;
}
MUnitBuilder.prototype.get_hand_hp = function(){
	return this.check_modification_of(_hands_hp);
}
MUnitBuilder.prototype.get_leg_hp = function(){
	return this.check_modification_of(_legs_hp);
}
MUnitBuilder.prototype.get_seg_hp = function(){
	return this.check_modification_of(_segments_hp);
}
MUnitBuilder.prototype.get_device_type = function(_device_link_param){
	var tsum = devices.length;
	if(_device_link_param<tsum)	return _device;
	tsum += engines.length;
	if(_device_link_param<tsum)	return _engine; 
	tsum += batteries.length;
	if(_device_link_param<tsum)	return _battery;
	tsum += weapons.length;
	if(_device_link_param<tsum)	return _weapon;
	tsum += armor_plates_1.length;
	if(_device_link_param<tsum) return _armor1;
	tsum += armor_shields.length;
	if(_device_link_param<tsum) return _shield;
	tsum += armor_plates_2.length;
	if(_device_link_param<tsum)	return _armor2;
	tsum += armor_plates_3.length;
	if(_device_link_param<tsum)	return _armor3;
}
MUnitBuilder.prototype.get_power_threshold = function(){
	return this.attr[_power_threshold].value;
}
MUnitBuilder.prototype.get_weight_multiplier = function(){
	return this.attr[_weight_multiplier].value;
}
MUnitBuilder.prototype.get_all_mods_cost = function(){
	return this.attr[_all_mods_cost].value;
}
MUnitBuilder.prototype.get_all_devices_cost = function(){
	return this.attr[_all_devices_cost].value;
} 
MUnitBuilder.prototype.get_all_devices_weight = function(){
	return this.attr[_all_devices_weight].value;
}
MUnitBuilder.prototype.get_material_weight = function(){
	return this.check_modification_of(_material_weight);
}
MUnitBuilder.prototype.get_material_cost = function(){
	return Math.ceil(this.check_modification_of(_material_cost));
}
MUnitBuilder.prototype.get_massive_damage = function(){
	return this.attr[_massive_damage].value;
}
MUnitBuilder.prototype.get_total_battery_load = function(){
	return this.attr[_total_battery_load].value;
}
MUnitBuilder.prototype.get_segment_type = function(seg_idx_param){
	return this.segments[seg_idx_param].attr[_segment_group].value;
}